[proof-new] Optimizing sat proof (#6324)
[cvc5.git] / configure.sh
index 52c280a56d0492e6190798d2680f2ff1f87f042c..cf6556375ab7a3c8a565c6216d8caa1a8921eff3 100755 (executable)
@@ -1,6 +1,8 @@
-#!/bin/sh
+#!/bin/bash
 #--------------------------------------------------------------------------#
 
+set -e -o pipefail
+
 usage () {
 cat <<EOF
 Usage: $0 [<build type>] [<option> ...]
@@ -10,68 +12,73 @@ Build types:
   debug
   testing
   competition
+  competition-inc
 
 
 General options;
   -h, --help               display this help and exit
   --prefix=STR             install directory
-  --build-prefix=STR       prefix build directory with given prefix
-  --name=STR               use custom build directory name
-  --best                   turn on dependences known to give best performance
-  --gpl                    permit GPL dependences, if available
+  --program-prefix=STR     prefix of binaries prepended on make install
+  --name=STR               use custom build directory name (optionally: +path)
+  --best                   turn on dependencies known to give best performance
+  --gpl                    permit GPL dependencies, if available
+  --arm64                  cross-compile for Linux ARM 64 bit
   --win64                  cross-compile for Windows 64 bit
+  --ninja                  use Ninja build system
+  --docs                   build Api documentation
 
 
 Features:
 The following flags enable optional features (disable with --no-<option name>).
   --static                 build static libraries and binaries [default=no]
-  --proofs                 support for proof generation
-  --optimized              optimize the build
+  --static-binary          statically link against system libraries
+                           (must be disabled for static macOS builds) [default=yes]
   --debug-symbols          include debug symbols
   --valgrind               Valgrind instrumentation
   --debug-context-mm       use the debug context memory manager
-  --statistics             do not include statistics
-  --replay                 turn off the replay feature
-  --assertions             turn off assertions
-  --tracing                remove all tracing code
-  --dumping                remove all dumping code
+  --statistics             include statistics
+  --assertions             turn on assertions
+  --tracing                include tracing code
+  --dumping                include dumping code
   --muzzle                 complete silence (no non-result output)
   --coverage               support for gcov coverage testing
   --profiling              support for gprof profiling
   --unit-testing           support for unit testing
-  --python2                prefer using Python 2 (for Python bindings)
-
-The following options configure parameterized features.
-
-  --language-bindings[=java,python,all]
-                          specify language bindings to build
+  --python2                force Python 2 (deprecated)
+  --python-bindings        build Python bindings based on new C++ API
+  --java-bindings          build Java bindings based on new C++ API
+  --all-bindings           build bindings for all supported languages
+  --asan                   build with ASan instrumentation
+  --ubsan                  build with UBSan instrumentation
+  --tsan                   build with TSan instrumentation
+  --werror                 build with -Werror
 
 Optional Packages:
 The following flags enable optional packages (disable with --no-<option name>).
   --cln                    use CLN instead of GMP
-  --gmp                    use GMP instead of CLN
   --glpk                   use GLPK simplex solver
   --abc                    use the ABC AIG library
   --cadical                use the CaDiCaL SAT solver
-  --cryptominisat          use the CRYPTOMINISAT sat solver
-  --lfsc                   use the LFSC proof checker
-  --symfpu                 use symfpu for floating point solver
-  --portfolio              build the multithreaded portfolio version of CVC4
-                           (pcvc4)
-  --readline               support the readline library
+  --cryptominisat          use the CryptoMiniSat SAT solver
+  --kissat                 use the Kissat SAT solver
+  --poly                   use the LibPoly library
+  --symfpu                 use SymFPU for floating point solver
+  --editline               support the editline library
 
 Optional Path to Optional Packages:
-  --abc-dir=PATH           path to top level of abc source tree
-  --antlr-dir=PATH         path to ANTLR C headers and libraries
+  --abc-dir=PATH           path to top level of ABC source tree
   --cadical-dir=PATH       path to top level of CaDiCaL source tree
-  --cryptominisat-dir=PATH path to top level of cryptominisat source tree
-  --cxxtest-dir=DIR        path to CxxTest installation
-  --glpk-dir=PATH          path to top level of glpk installation
+  --cryptominisat-dir=PATH path to top level of CryptoMiniSat source tree
+  --glpk-dir=PATH          path to top level of GLPK installation
   --gmp-dir=PATH           path to top level of GMP installation
-  --lfsc-dir=PATH          path to top level of lfsc source tree
-  --symfpu-dir=PATH        path to top level of symfpu source tree
+  --kissat-dir=PATH        path to top level of Kissat source tree
+  --poly-dir=PATH          path to top level of LibPoly source tree
+  --symfpu-dir=PATH        path to top level of SymFPU source tree
+
+Build limitations:
+  --lib-only               only build the library, but not the executable or
+                           the parser (default: off)
 
-Report bugs to <cvc4-bugs@cs.stanford.edu>.
 EOF
   exit 0
 }
@@ -93,10 +100,9 @@ msg () {
 
 #--------------------------------------------------------------------------#
 
-build_dir=production
+build_dir=build
 install_prefix=default
-build_prefix=""
-build_name=""
+program_prefix=""
 
 #--------------------------------------------------------------------------#
 
@@ -105,45 +111,50 @@ buildtype=default
 abc=default
 asan=default
 assertions=default
-best=default
 cadical=default
 cln=default
+comp_inc=default
 coverage=default
 cryptominisat=default
-debug_symbols=default
 debug_context_mm=default
+debug_symbols=default
+docs=default
 dumping=default
-gpl=default
-win64=default
 glpk=default
-lfsc=default
+gpl=default
+kissat=default
+poly=default
 muzzle=default
-optimized=default
-portfolio=default
-proofs=default
-replay=default
+ninja=default
+profiling=default
+python2=default
+python_bindings=default
+java_bindings=default
+editline=default
 shared=default
+static_binary=default
 statistics=default
 symfpu=default
 tracing=default
+tsan=default
+ubsan=default
 unit_testing=default
-python2=default
 valgrind=default
-profiling=default
-readline=default
-
-language_bindings_java=default
-language_bindings_python=default
+win64=default
+arm64=default
+werror=default
 
 abc_dir=default
-antlr_dir=default
 cadical_dir=default
 cryptominisat_dir=default
 glpk_dir=default
 gmp_dir=default
-lfsc_dir=default
+kissat_dir=default
+poly_dir=default
 symfpu_dir=default
 
+lib_only=default
+
 #--------------------------------------------------------------------------#
 
 while [ $# -gt 0 ]
@@ -158,11 +169,26 @@ do
     --asan) asan=ON;;
     --no-asan) asan=OFF;;
 
+    --ubsan) ubsan=ON;;
+    --no-ubsan) ubsan=OFF;;
+
+    --tsan) tsan=ON;;
+    --no-tsan) tsan=OFF;;
+
+    --werror) werror=ON;;
+
     --assertions) assertions=ON;;
     --no-assertions) assertions=OFF;;
 
-    --best) best=ON;;
-    --no-best) best=OFF;;
+    # Best configuration
+    --best)
+      abc=ON
+      cadical=ON
+      cln=ON
+      cryptominisat=ON
+      glpk=ON
+      editline=ON
+      ;;
 
     --prefix) die "missing argument to $1 (try -h)" ;;
     --prefix=*)
@@ -175,11 +201,11 @@ do
         esac
         ;;
 
-    --build-prefix) die "missing argument to $1 (try -h)" ;;
-    --build-prefix=*) build_prefix=${1##*=} ;;
+    --program-prefix) die "missing argument to $1 (try -h)" ;;
+    --program-prefix=*) program_prefix=${1##*=} ;;
 
     --name) die "missing argument to $1 (try -h)" ;;
-    --name=*) build_name=${1##*=} ;;
+    --name=*) build_dir=${1##*=} ;;
 
     --cadical) cadical=ON;;
     --no-cadical) cadical=OFF;;
@@ -196,8 +222,8 @@ do
     --debug-symbols) debug_symbols=ON;;
     --no-debug-symbols) debug_symbols=OFF;;
 
-    --debug-context-memory-manager) debug_context_mm=ON;;
-    --no-debug-context-memory-manager) debug_context_mm=OFF;;
+    --debug-context-mm) debug_context_mm=ON;;
+    --no-debug-context-mm) debug_context_mm=OFF;;
 
     --dumping) dumping=ON;;
     --no-dumping) dumping=OFF;;
@@ -205,33 +231,33 @@ do
     --gpl) gpl=ON;;
     --no-gpl) gpl=OFF;;
 
+    --kissat) kissat=ON;;
+    --no-kissat) kissat=OFF;;
+
     --win64) win64=ON;;
-    --no-win64) win64=OFF;;
+
+    --arm64) arm64=ON;;
+
+    --ninja) ninja=ON;;
+
+    --docs) docs=ON;;
+    --no-docs) docs=OFF;;
 
     --glpk) glpk=ON;;
     --no-glpk) glpk=OFF;;
 
-    --lfsc) lfsc=ON;;
-    --no-lfsc) lfsc=OFF;;
+    --poly) poly=ON;;
+    --no-poly) poly=OFF;;
 
     --muzzle) muzzle=ON;;
     --no-muzzle) muzzle=OFF;;
 
-    --optimized) optimized=ON;;
-    --no-optimized) optimized=OFF;;
-
-    --portfolio) portfolio=ON;;
-    --no-portfolio) portfolio=OFF;;
-
-    --proofs) proofs=ON;;
-    --no-proofs) proofs=OFF;;
-
-    --replay) replay=ON;;
-    --no-replay) replay=OFF;;
-
-    --static) shared=OFF;;
+    --static) shared=OFF; static_binary=ON;;
     --no-static) shared=ON;;
 
+    --static-binary) static_binary=ON;;
+    --no-static-binary) static_binary=OFF;;
+
     --statistics) statistics=ON;;
     --no-statistics) statistics=OFF;;
 
@@ -247,38 +273,28 @@ do
     --python2) python2=ON;;
     --no-python2) python2=OFF;;
 
+    --python-bindings) python_bindings=ON;;
+    --no-python-bindings) python_bindings=OFF;;
+
+    --java-bindings) java_bindings=ON;;
+    --no-java-bindings) java_bindings=OFF;;
+
+    --all-bindings)
+      python_bindings=ON
+      java_bindings=ON;;
+
     --valgrind) valgrind=ON;;
     --no-valgrind) valgrind=OFF;;
 
     --profiling) profiling=ON;;
     --no-profiling) profiling=OFF;;
 
-    --readline) readline=ON;;
-    --no-readline) readline=OFF;;
-
-    --language-bindings) die "missing argument to $1 (try -h)" ;;
-    --language-bindings=*)
-      lang="${1##*=}"
-      IFS=','
-      for l in $lang; do
-        case $l in
-          java) language_bindings_java=ON ;;
-          python) language_bindings_python=ON ;;
-          all)
-            language_bindings_python=ON
-            language_bindings_java=ON ;;
-          *) die "invalid language binding '$l' specified  (try -h)" ;;
-        esac
-      done
-      unset IFS
-      ;;
+    --editline) editline=ON;;
+    --no-editline) editline=OFF;;
 
     --abc-dir) die "missing argument to $1 (try -h)" ;;
     --abc-dir=*) abc_dir=${1##*=} ;;
 
-    --antlr-dir) die "missing argument to $1 (try -h)" ;;
-    --antlr-dir=*) antlr_dir=${1##*=} ;;
-
     --cadical-dir) die "missing argument to $1 (try -h)" ;;
     --cadical-dir=*) cadical_dir=${1##*=} ;;
 
@@ -291,20 +307,26 @@ do
     --gmp-dir) die "missing argument to $1 (try -h)" ;;
     --gmp-dir=*) gmp_dir=${1##*=} ;;
 
-    --lfsc-dir) die "missing argument to $1 (try -h)" ;;
-    --lfsc-dir=*) lfsc_dir=${1##*=} ;;
+    --kissat-dir) die "missing argument to $1 (try -h)" ;;
+    --kissat-dir=*) kissat_dir=${1##*=} ;;
+
+    --poly-dir) die "missing argument to $1 (try -h)" ;;
+    --poly-dir=*) poly_dir=${1##*=} ;;
 
     --symfpu-dir) die "missing argument to $1 (try -h)" ;;
     --symfpu-dir=*) symfpu_dir=${1##*=} ;;
 
+    --lib-only) lib_only=ON ;;
+
     -*) die "invalid option '$1' (try -h)";;
 
     *) case $1 in
-         production)  buildtype=Production; build_dir=production;;
-         debug)       buildtype=Debug; build_dir=debug;;
-         testing)     buildtype=Testing; build_dir=testing;;
-         competition) buildtype=Competition; build_dir=competition;;
-         *)           die "invalid build type (try -h)";;
+         production)      buildtype=Production;;
+         debug)           buildtype=Debug;;
+         testing)         buildtype=Testing;;
+         competition)     buildtype=Competition;;
+         competition-inc) buildtype=Competition; comp_inc=ON;;
+         *)               die "invalid build type (try -h)";;
        esac
        ;;
   esac
@@ -313,108 +335,85 @@ done
 
 #--------------------------------------------------------------------------#
 
+if [ $werror != default ]; then
+  export CFLAGS=-Werror
+  export CXXFLAGS=-Werror
+fi
+
 cmake_opts=""
 
 [ $buildtype != default ] \
   && cmake_opts="$cmake_opts -DCMAKE_BUILD_TYPE=$buildtype"
 
 [ $asan != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_ASAN=$asan" \
-  && [ $asan = ON ] && build_dir="$build_dir-asan"
+  && cmake_opts="$cmake_opts -DENABLE_ASAN=$asan"
+[ $ubsan != default ] \
+  && cmake_opts="$cmake_opts -DENABLE_UBSAN=$ubsan"
+[ $tsan != default ] \
+  && cmake_opts="$cmake_opts -DENABLE_TSAN=$tsan"
 [ $assertions != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_ASSERTIONS=$assertions" \
-  && [ $assertions = ON ] && build_dir="$build_dir-assertions"
-[ $best != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_BEST=$best" \
-  && [ $best = ON ] && build_dir="$build_dir-best"
+  && cmake_opts="$cmake_opts -DENABLE_ASSERTIONS=$assertions"
+[ $comp_inc != default ] \
+  && cmake_opts="$cmake_opts -DENABLE_COMP_INC_TRACK=$comp_inc"
 [ $coverage != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_COVERAGE=$coverage" \
-  && [ $coverage = ON ] && build_dir="$build_dir-coverage"
+  && cmake_opts="$cmake_opts -DENABLE_COVERAGE=$coverage"
 [ $debug_symbols != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_DEBUG_SYMBOLS=$debug_symbols" \
-  && [ $debug_symbols = ON ] && build_dir="$build_dir-debug_symbols"
+  && cmake_opts="$cmake_opts -DENABLE_DEBUG_SYMBOLS=$debug_symbols"
 [ $debug_context_mm != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_DEBUG_CONTEXT_MM=$debug_context_mm" \
-  && [ $debug_context_mm = ON ] &&  build_dir="$build_dir-debug_context_mm"
+  && cmake_opts="$cmake_opts -DENABLE_DEBUG_CONTEXT_MM=$debug_context_mm"
 [ $dumping != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_DUMPING=$dumping" \
-  && [ $dumping = ON ] &&  build_dir="$build_dir-dumping"
+  && cmake_opts="$cmake_opts -DENABLE_DUMPING=$dumping"
 [ $gpl != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_GPL=$gpl" \
-  && [ $gpl = ON ] &&  build_dir="$build_dir-gpl"
+  && cmake_opts="$cmake_opts -DENABLE_GPL=$gpl"
 [ $win64 != default ] \
-  && cmake_opts="$cmake_opts -DCMAKE_TOOLCHAIN_FILE=../cmake/Toolchain-mingw64.cmake" \
-  && [ $win64 = ON ] &&  build_dir="$build_dir-win64"
+  && cmake_opts="$cmake_opts -DCMAKE_TOOLCHAIN_FILE=../cmake/Toolchain-mingw64.cmake"
+[ $arm64 != default ] \
+  && cmake_opts="$cmake_opts -DCMAKE_TOOLCHAIN_FILE=../cmake/Toolchain-aarch64.cmake"
+[ $ninja != default ] && cmake_opts="$cmake_opts -G Ninja"
 [ $muzzle != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_MUZZLE=$muzzle" \
-  && [ $muzzle = ON ] &&  build_dir="$build_dir-muzzle"
-[ $optimized != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_OPTIMIZED=$optimized" \
-  && [ $optimized = ON ] &&  build_dir="$build_dir-optimized"
-[ $portfolio != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_PORTFOLIO=$portfolio" \
-  && [ $portfolio = ON ] &&  build_dir="$build_dir-portfolio"
-[ $proofs != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_PROOFS=$proofs" \
-  && [ $proofs = ON ] &&  build_dir="$build_dir-proofs"
-[ $replay != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_REPLAY=$replay" \
-  && [ $replay = ON ] &&  build_dir="$build_dir-replay"
+  && cmake_opts="$cmake_opts -DENABLE_MUZZLE=$muzzle"
 [ $shared != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_SHARED=$shared" \
-  && [ $shared = OFF ] &&  build_dir="$build_dir-static"
+  && cmake_opts="$cmake_opts -DENABLE_SHARED=$shared"
+[ $static_binary != default ] \
+  && cmake_opts="$cmake_opts -DENABLE_STATIC_BINARY=$static_binary"
 [ $statistics != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_STATISTICS=$statistics" \
-  && [ $statistics = ON ] && build_dir="$build_dir-stastitics"
+  && cmake_opts="$cmake_opts -DENABLE_STATISTICS=$statistics"
 [ $tracing != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_TRACING=$tracing" \
-  && [ $tracing = ON ] && build_dir="$build_dir-tracing"
+  && cmake_opts="$cmake_opts -DENABLE_TRACING=$tracing"
 [ $unit_testing != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_UNIT_TESTING=$unit_testing" \
-  && [ $unit_testing = ON ] && build_dir="$build_dir-unit_testing"
+  && cmake_opts="$cmake_opts -DENABLE_UNIT_TESTING=$unit_testing"
 [ $python2 != default ] \
-  && cmake_opts="$cmake_opts -DUSE_PYTHON2=$python2" \
-  && [ $python2 = ON ] && build_dir="$build_dir-python2"
+  && cmake_opts="$cmake_opts -DUSE_PYTHON2=$python2"
+[ $docs != default ] \
+  && cmake_opts="$cmake_opts -DBUILD_DOCS=$docs"
+[ $python_bindings != default ] \
+  && cmake_opts="$cmake_opts -DBUILD_BINDINGS_PYTHON=$python_bindings"
+[ $java_bindings != default ] \
+  && cmake_opts="$cmake_opts -DBUILD_BINDINGS_JAVA=$java_bindings"
 [ $valgrind != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_VALGRIND=$valgrind" \
-  && [ $valgrind = ON ] && build_dir="$build_dir-valgrind"
+  && cmake_opts="$cmake_opts -DENABLE_VALGRIND=$valgrind"
 [ $profiling != default ] \
-  && cmake_opts="$cmake_opts -DENABLE_PROFILING=$profiling" \
-  && [ $profiling = ON ] && build_dir="$build_dir-profiling"
-[ $readline != default ] \
-  && cmake_opts="$cmake_opts -DUSE_READLINE=$readline" \
-  && [ $readline = ON ] && build_dir="$build_dir-readline"
+  && cmake_opts="$cmake_opts -DENABLE_PROFILING=$profiling"
+[ $editline != default ] \
+  && cmake_opts="$cmake_opts -DUSE_EDITLINE=$editline"
 [ $abc != default ] \
-  && cmake_opts="$cmake_opts -DUSE_ABC=$abc" \
-  && [ $abc = ON ] && build_dir="$build_dir-abc"
+  && cmake_opts="$cmake_opts -DUSE_ABC=$abc"
 [ $cadical != default ] \
-  && cmake_opts="$cmake_opts -DUSE_CADICAL=$cadical" \
-  && [ $cadical = ON ] && build_dir="$build_dir-cadical"
+  && cmake_opts="$cmake_opts -DUSE_CADICAL=$cadical"
 [ $cln != default ] \
-  && cmake_opts="$cmake_opts -DUSE_CLN=$cln" \
-  && [ $cln = ON ] && build_dir="$build_dir-cln"
+  && cmake_opts="$cmake_opts -DUSE_CLN=$cln"
 [ $cryptominisat != default ] \
-  && cmake_opts="$cmake_opts -DUSE_CRYPTOMINISAT=$cryptominisat" \
-  && [ $cryptominisat = ON ] && build_dir="$build_dir-cryptominisat"
+  && cmake_opts="$cmake_opts -DUSE_CRYPTOMINISAT=$cryptominisat"
 [ $glpk != default ] \
-  && cmake_opts="$cmake_opts -DUSE_GLPK=$glpk" \
-  && [ $glpk = ON ] && build_dir="$build_dir-glpk"
-[ $lfsc != default ] \
-  && cmake_opts="$cmake_opts -DUSE_LFSC=$lfsc" \
-  && [ $lfsc = ON ] && build_dir="$build_dir-lfsc"
+  && cmake_opts="$cmake_opts -DUSE_GLPK=$glpk"
+[ $kissat != default ] \
+  && cmake_opts="$cmake_opts -DUSE_KISSAT=$kissat"
+[ $poly != default ] \
+  && cmake_opts="$cmake_opts -DUSE_POLY=$poly"
 [ $symfpu != default ] \
-  && cmake_opts="$cmake_opts -DUSE_SYMFPU=$symfpu" \
-  && [ $symfpu = ON ] && build_dir="$build_dir-symfpu"
-
-[ $language_bindings_java != default ] \
-  && cmake_opts="$cmake_opts -DBUILD_BINDINGS_JAVA=$language_bindings_java"
-[ $language_bindings_python != default ] \
-  && cmake_opts="$cmake_opts -DBUILD_BINDINGS_PYTHON=$language_bindings_python"
-
+  && cmake_opts="$cmake_opts -DUSE_SYMFPU=$symfpu"
 [ "$abc_dir" != default ] \
   && cmake_opts="$cmake_opts -DABC_DIR=$abc_dir"
-[ "$antlr_dir" != default ] \
-  && cmake_opts="$cmake_opts -DANTLR_DIR=$antlr_dir"
 [ "$cadical_dir" != default ] \
   && cmake_opts="$cmake_opts -DCADICAL_DIR=$cadical_dir"
 [ "$cryptominisat_dir" != default ] \
@@ -423,41 +422,30 @@ cmake_opts=""
   && cmake_opts="$cmake_opts -DGLPK_DIR=$glpk_dir"
 [ "$gmp_dir" != default ] \
   && cmake_opts="$cmake_opts -DGMP_DIR=$gmp_dir"
-[ "$lfsc_dir" != default ] \
-  && cmake_opts="$cmake_opts -DLFSC_DIR=$lfsc_dir"
+[ "$kissat_dir" != default ] \
+  && cmake_opts="$cmake_opts -DKISSAT=$kissat_dir"
+[ "$poly_dir" != default ] \
+  && cmake_opts="$cmake_opts -DPOLY_DIR=$poly_dir"
 [ "$symfpu_dir" != default ] \
   && cmake_opts="$cmake_opts -DSYMFPU_DIR=$symfpu_dir"
+[ "$lib_only" != default ] \
+    && cmake_opts="$cmake_opts -DBUILD_LIB_ONLY=$lib_only"
 [ "$install_prefix" != default ] \
   && cmake_opts="$cmake_opts -DCMAKE_INSTALL_PREFIX=$install_prefix"
+[ -n "$program_prefix" ] \
+  && cmake_opts="$cmake_opts -DPROGRAM_PREFIX=$program_prefix"
 
 root_dir=$(pwd)
 
-if [ -n "$build_name" ]; then
-  # If a build name is specified just create directory 'build_name' for the
-  # current build.
-  build_dir=$build_name
-
-  # The cmake toolchain can't be changed once it is configured in $build_dir.
-  # Thus, remove $build_dir and create an empty directory.
-  [ $win64 = ON ] && [ -e "$build_dir" ] && rm -r "$build_dir"
-  mkdir -p "$build_name"
-else
-  # If no build name is specified create 'cmake-builds' directory and create
-  # the current build directory. Set symlink 'cmake-builds/build/' to current
-  # build.
-  build_dir="$build_prefix$build_dir"
-
-  # The cmake toolchain can't be changed once it is configured in $build_dir.
-  # Thus, remove $build_dir and create an empty directory.
-  [ $win64 = ON ] && [ -e "cmake-build/$build_dir" ] \
-    && rm -r "cmake-builds/$build_dir"
-  mkdir -p "cmake-builds/$build_dir"
-  cd cmake-builds || exit 1
-  [ -e build ] && rm build
-  ln -s "$build_dir" build  # link to current build directory
-fi
+# The cmake toolchain can't be changed once it is configured in $build_dir.
+# Thus, remove $build_dir and create an empty directory.
+[ $win64 = ON ] && [ -e "$build_dir" ] && rm -r "$build_dir"
+[ $arm64 = ON ] && [ -e "$build_dir" ] && rm -r "$build_dir"
+mkdir -p "$build_dir"
 
-cd "$build_dir" || exit 1
+cd "$build_dir"
 
 [ -e CMakeCache.txt ] && rm CMakeCache.txt
-cmake "$root_dir" $cmake_opts
+build_dir_escaped=$(echo "$build_dir" | sed 's/\//\\\//g')
+cmake "$root_dir" $cmake_opts 2>&1 | \
+  sed "s/^Now just/Now change to '$build_dir_escaped' and/"